;
;	Setting registers on CT65535 for PC110
;
;		2018.10.01
;		2018.10.09
;		2018.10.16
;		2018.10.19
;		2018.10.21	/t=TFT /c=CRT
;		2018.10.22
;
;
code	segment
	assume	cs:code,ds:code,es:code,ss:code
;----------------------------------------------
;ASCII
bs	equ	08h
cr	equ	0dh
lf	equ	0ah
;DOS int
rdky	equ	01h		;al
wrch	equ	02h		;dl
rdch	equ	08h		;al
wrln	equ	09h		;ds:dx
rdln	equ	0ah		;ds:dx | Enter for end
drtn	equ	4ch
;Index register & Value of register
ireg	equ	3d6h
vreg	equ	3d7h
;
DOS	macro	cmd
	mov	ah,cmd
	int	21h
	endm
;-----------------------------------------------
	org	100h
start:	jmp	init
;parameter table
trtbl:
	db	06h,0c0h	;No color reduction
;	db	16h,00h
;	db	17h,00h		;H Over flow
;	db	18h,0ffh	;Disp End
	db	19h,00h		;Alt Hsync Start(CR04)
	db	1ah,7fh		;Alt Hsync End(CR05)
	db	1bh,0efh	;0a0h	;Alt H Total(CR00)
	db	1ch,7fh		;Panel Width
	db	1dh,00h
	db	2ch,00h		;FLM Delay
	db	2dh,9fh		;LP Delay
	db	2eh,9fh		;LP Delay
	db	2fh,01h		;LP Plus Width
	db	4fh,0c6h	;LP/M change to DE
	db	50h,0ah		;Clock divide, Dither, FRC
	db	51h,0c4h	;change to LCD on 4h !!!
	db	52h,42h		;for 'Panel On'
	db	53h,00h		;for FRC
	db	54h,0c8h	;Negative Polarity
	db	55h,0e5h	;H Auto Doubling
	db	56h,02h		;H Centering
	db	57h,00h		;V Stretch Mode
;	db	58h,00h		;V Centering
	db	59h,00h		;V H/W Line Replication
	db	5ah,04h		;V Line Repl Height
;	db	5bh,8fh
;	db	5dh,10h
;	db	5eh,80h	
	db	64h,0e0h
	db	65h,27h		;Alt V Total(CR06)
;	db	66h,0e0h	;Alt Vsync Start(CR10)
	db	67h,0ch		;Alt Vsync End(CR11)
	db	68h,0e0h	;Panel Height / low
;	db	72h,04h		;Device IO
	db	0ffh,0ffh
;table end
;register table
crtbl:
	db	06h,0c0h
;	db	16h,00h
;	db	17h,00h
;	db	18h,0ffh
	db	19h,01h
	db	1ah,19h
	db	1bh,59h
	db	1ch,7fh
	db	1dh,7fh
	db	2ch,04h
	db	2dh,50h
	db	2eh,50h
	db	2fh,00h
	db	4fh,04h
	db	50h,15h
	db	51h,63h		;Change to CRT !!!
	db	52h,42h
	db	53h,00h
	db	54h,3ah
	db	55h,0e5h
	db	56h,00h
	db	57h,03h
;	db	58h,00h
	db	59h,04h
	db	5ah,04h
;	db	5bh,8fh
;	db	5dh,10h
;	db	5eh,80h
	db	64h,0e4h
	db	65h,07h
;	db	66h,0e0h
	db	67h,01h
	db	68h,0dfh
;	db	72h,04h
	db	0ffh,0ffh
;head message
hmsg:	db	cr,lf,'+++ CT65535 Registers Setter for TFT/CRT 2018.10 +++',cr,lf,'$'
;
;program start point
init:	mov	ax,cs
	mov	es,ax
	mov	ds,ax
	mov	ss,ax
	mov	sp,offset stack

	mov	si,offset 80h
rdcml:	mov	al,byte ptr[si]
	and	al,al
	jz	rdcme
rdcm0:	inc	si
	mov	al,byte ptr[si]
	cmp	al,0dh
	je	rdcme
	cmp	al,2fh		;=/
	jne	rdcm0
	mov	al,byte ptr[si+1]
	and	al,0dfh		;upper to lower
	cmp	al,'C'
	je	cgcrt
	cmp	al,'T'
	jne	rdcm0
;TFT
cgtft:	call	streg
	xor	al,al
	DOS	drtn
;CRT
cgcrt:	call	screg
	xor	al,al
	DOS	drtn
	
rdcme:	lea 	dx,hmsg
	DOS	wrln
	call	dcreg		;disp current reg
ini0:	call	crlf
	DOS	rdky
	cmp	al,'q'
	jne	ini1
	xor	al,al
	DOS	drtn
ini1:	call	crcr
	cmp	al,'s'
	jne	ini2
	call	dsreg
	jmp	ini0
ini2:	cmp	al,'t'
	jne	ini3
	call	dtreg
	jmp	ini0
ini3:	cmp	al,'w'
	jne	ini4
	call	wtreg
	jmp	ini0
ini4:	cmp	al,'r'
	jne	ini5
	call	wsreg
	jmp	ini0
ini5:	cmp	al,'c'
	jne	ini6
	call	dcreg
	jmp	ini0
ini6:	cmp	al,'S'
	jne	ini7
	call	SRREG
	jmp	inie
ini7:	cmp	al,'G'
	jne	ini8
	call	GRREG
	jmp	inie
ini8:	cmp	al,'A'
	jne	ini9
	call	ARREG
	jmp	inie
ini9:	cmp	al,'x'
	je	ixnum
inie:	jmp	ini0
;
ixnum:	lea	dx,xrmsg
	DOS	wrln
ixnm0:	DOS	rdky
	cmp	al,'0'
	jnc	ixnm1
	jmp	ixnme
ixnm1:	cmp	al,'9'+1
	jnc	ixnme
	call	rwreg
ixnme:	jmp	ini0
xrmsg:	db	cr,lf,'Read/Write XR Registers',cr,lf,'$'
;-------------------------------------------------
;disply command message
dcmsg:	lea	dx,cmsg
	DOS	wrln
	ret
;-------------------------------------------------
;read and save current CRT register to trtbl+gap
;only one time
ssreg:	lea 	di,crtbl
ssrg0:	mov	al,byte ptr[di]
	cmp	al,0ffh
	jne	ssrg1
	call	crlf
	ret
ssrg1:	mov	dx,3d6h
	out	dx,al			;set reg addr
	mov	dx,3d7h
	in	al,dx			;get reg data
	mov	byte ptr[di+1],al
	add	di,2
	jmp	ssrg0
;--------------------------------------------------
;Display SRREG, GRREG, ARREG
SRREG:	lea	dx,SRmsg
	DOS	wrln
	mov	cl,8
	mov	ch,0
SRRG0:	mov	al,ch
	mov	dx,3c4h
	out	dx,al
	call	dshx
	mov	dx,3c5h
	in	al,dx
	call	dshx
	call	dssp
	inc	ch
	dec	cl
	jne	SRRG0
	call	crlf
	ret

GRREG:	lea	dx,GRmsg
	DOS	wrln
	mov	cl,9
	mov	ch,0
GRRG0:	mov	al,ch
	mov	dx,3ceh
	out	dx,al
	call	dshx
	mov	dx,3cfh
	in	al,dx
	call	dshx
	call	dssp
	inc	ch
	dec	cl
	jne	GRRG0
	call	crlf
	ret

ARREG:	lea	dx,ARmsg
	DOS	wrln
	mov	cl,14h
	mov	ch,20h
ARRG0:	mov	al,ch
	mov	dx,3c0h
	out	dx,al
	and	al,1fh
	call	dshx
	mov	dx,3c1h
	in	al,dx
	call	dshx
	call	dssp
	inc	ch
	dec	cl
	jne	ARRG0
	call	crlf
	ret

SRmsg:	db	cr,lf,'Display SR Registers',cr,lf,'$'
GRmsg:	db	cr,lf,'Display GR Registers',cr,lf,'$'
ARmsg:	db	cr,lf,'Display AR Registers',cr,lf,'$'
;--------------------------------------------------
;write CRT table value to registers
wsreg:	lea	dx,smsg
	DOS	wrln
	lea	si,crtbl
wsrg0:	mov	al,byte ptr[si]
	cmp	al,0ffh
	jne	wsrg1
	call	crlf
	ret
wsrg1:	mov	dx,3d6h
	out	dx,al
	call	dshx
	mov	al,byte ptr[si+1]
	mov	dx,3d7h
	out	dx,al
	call	dshx
	call	dssp
	add	si,2
	jmp	wsrg0
;------------------------------------------------
;display CRT register values
dsreg:	lea	dx,smsg
	DOS	wrln
	lea	si,crtbl
dsrg0:	mov	al,byte ptr[si]
	cmp	al,0ffh
	jne	dsrg1
	call	crlf
	ret
dsrg1:	call	dshx
	mov	al,byte ptr[si+1]
	call	dshx
	call	dssp
	add	si,2
	jmp	dsrg0
;------------------------------------------------
;display TFT table value
dtreg:	lea	dx,tmsg
	DOS	wrln
	lea	si,trtbl
dtrg0:	mov	al,byte ptr[si]
	cmp	al,0ffh
	jne	dtrg1
	call	crlf
	ret
dtrg1:	call	dshx
	mov	al,byte ptr[si+1]
	call	dshx
	call	dssp
	add	si,2
	jmp	dtrg0
;------------------------------------------------
;write TFT value to registers
wtreg:	lea	dx,tmsg
	DOS	wrln
	lea	si,trtbl
wtrg0:	mov	al,byte ptr[si]
	cmp	al,0ffh
	jne	wtrg1
	call	crlf
	ret
wtrg1:	call	dshx
	mov	dx,3d6h
	out	dx,al
	mov	al,byte ptr[si+1]
	mov	dx,3d7h
	out	dx,al
	call	dshx
	call	dssp
	add	si,2
	jmp	wtrg0
;------------------------------------------------
;set TFT value to registers
streg:	lea	si,trtbl		;TFT table
	jmp	strg0
;--------------------------------------------------
;set CRT table value to registers
screg:	lea	si,crtbl		;CRT table

strg0:	mov	al,byte ptr[si]
	cmp	al,0ffh
	jne	strg1
	ret
strg1:	mov	dx,3d6h
	out	dx,al
	mov	al,byte ptr[si+1]
	mov	dx,3d7h
	out	dx,al
	add	si,2
	jmp	strg0
;------------------------------------------------
;read & write single register
rwreg:	push	ax
;	mov	dl,al
;	DOS	wrch
	pop	ax
	shl	al,1	;1-9 only !!!
	shl	al,1
	shl	al,1
	shl	al,1
	and	al,0f0h
	mov	cl,al
	DOS	rdky
	call	cknum
	jnc	rwrg1
	ret
rwrg1:	push	ax
	push	cx
	call	dssp
	pop	cx
	pop	ax
	and	al,0fh
	add	al,cl
	mov	dx,3d6h
	out	dx,al		;keep same index !
	mov	dx,3d7h
	in	al,dx
	call	dshx
	call	dssp
rwrg2:	lea	dx,kbuf
	DOS	rdln
	lea	si,kbuf
	mov	al,byte ptr[si+1]
	cmp	al,2
	jne	rwrge
rwrg3:	mov	al,byte ptr[si+2]
	call	abcnv
	jc	rwrge
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1
	mov	cl,al
	mov	al,byte ptr[si+3]
	call	abcnv
	jc	rwrge
	add	al,cl
	mov	dx,3d7h
	out	dx,al
	ret
rwrge:
	ret
;-----------------------------------------------
;Display Current register value
dcreg:	lea	dx,jmsg
	DOS	wrln
	lea	si,trtbl
dcrg0:	mov	al,byte ptr[si]
	cmp	al,0ffh
	jne	dcrg1
	call	crlf
	ret
dcrg1:	mov	dx,3d6h
	out	dx,al
	call	dshx
	mov	dx,3d7h
	in	al,dx
	call	dshx
	call	dssp
	add	si,2
	jmp	dcrg0
;-----------------------------------------------
;check a char number
cknum:	cmp	al,40h
	jc	cknm0
	and	al,4fh
ckaf0:	cmp	al,'A'
	jnc	ckaf1
	ret
ckaf1:	sub	al,7
	cmp	al,40h
	cmc
	ret
cknm0:	cmp	al,'0'
	jnc	cknm1
	ret
cknm1:	cmp	al,'9'+1
	cmc
	ret
;------------------------------------------------
; 1 asc to bin convert
abcnv:	cmp	al,40h
	jc	abcn0
	and	al,4fh
abcn0:	sub	al,'0'
	jnc	abcn1
	ret
abcn1:	cmp	al,11
	jc	abcn3
	sub	al,7
abcn2:	cmp	al,16
abcn3:	cmc
	ret
;------------------------------------------------
;display hex on al
dshx:	push	dx
push	ax
	push	ax
	and	al,0f0h
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	add	al,'0'
	cmp	al,'9'+1
	jc	dsh1
	add	al,7
dsh1:	mov	dl,al
	DOS	wrch
	pop	ax
	and	al,0fh
	add	al,'0'
	cmp	al,'9'+1
	jc	dsh2
	add	al,7
dsh2:	mov	dl,al
	DOS	wrch
	pop	ax
	pop	dx
	ret
;
dssp:	mov	dl,' '
	DOS	wrch
	ret
;------------------------------------------------
crlf:	push	ax
	push	dx
	mov	dl,cr
	DOS	wrch
	mov	dl,lf
	DOS	wrch
	pop	dx
	pop	ax
	ret
crcr:	push	ax
	push	dx
	mov	dl,cr
	DOS	wrch
	pop	dx
	pop	ax
	ret
;------------------------------------------------
;messages
smsg:	db	'CRT Register Values ('
cmsg:	db	'q=quit, s=show CRT, t=show TFT, w=write TFT, r=restor CRT)',cr,lf,'$'
tmsg:	db	'TFT Register Values ('
	db	'q=quit, s=show CRT, t=show TFT, w=write TFT, r=restor CRT)',cr,lf,'$'
jmsg	db	'Current Reg Value   ('
	db	'q=quit, s=show CRT, t=show TFT, w=write TFT, r=restor CRT)',cr,lf,'$'
;parameter table
	db	0ffh,0ffh
;table end
;
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0,0
	db	0ffh,0ffh
;table end
;
kbuf:	db	3,0,0,0,0ch

	db	256 dup(?)
stack:
;
code	ends
	end	start
